#include <iostream>
#include <string>

// g++ -std=c++11 -o exitcode exitcode.cpp

// exitcode
//
// ... by Eli Fulkerson.  See http://www.elifulkerson.com for updates
//
// exitcode takes a single word in from stdin - that is, the first word of the first line,
// discarding all else.  It then converts it into an integer and exits with that code.

// ... because I want to use the output of wc | awk '{print $1}' in a bash script and
// check against it with -eq, for complex reasons of my own and all the other ways
// (spawning subshells, etc) appear to be fucking magic

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


using namespace std;

int main(int argc, char* argv[]) {


	for ( int i = 0; i < argc; i++) {

		std::string arg = argv[i];

		if (arg == "-v" || arg == "--version") {
			cout << "exitcode v0.1  3 August 2016" << endl
				 << "Converts first word of stdin into an exit code, 0-255" << endl
				 << "by Eli Fulkerson.  See http://www.elifulkerson.com for updates" << endl << flush;
			return 0;
		}


		if (arg == "-h" || arg == "--help" || arg == "--usage") {
			cout << "Syntax: your_command |exitcode" << endl
				 << "Options:" << endl
				 << "-v     : Display version information" << endl << flush;
			return 0;
		}
	}

	string val;
	cin >> val;

	int x = atoi(val.c_str());

	if (x < 0 || x > 255) {
		cerr << "Warning - exitcode cannot return " << x << " you will see " << x << " % 256 when you check $?" << endl;
	}
	
	return x;
}
